#!/usr/bin/perl
################################################################################
# eWLA (e Web Log Analyzer)                         Version 0.1                #
# Copyright 2000 Frederic TYNDIUK (FTLS)            All Rights Reserved.       #
# E-Mail: tyndiuk@ftls.org                          Script License: GPL        #
# Created  05/31/00                                 Last Modified 05/25/00     #
# Scripts Archive at:                               http://www.ftls.org/cgi/   #
################################################################################
# Creates multi-page HTML reports of Apache log statistics.                    #
#   Calendar cgi.                                                              #
################################################################################
########################## license & copyright header ##########################
#                                                                              #
#                     Copyright (c) 2000 by TYNDIUK Frederic                   #
#                                                                              #
#       This program is free software; you can redistribute it and/or          #
#       modify it under the terms of the GNU General Public License as         #
#       published by the Free Software Foundation; either version 2 of         #
#       the License, or (at your option) any later version.                    #
#                                                                              #
#       This program is distributed in the hope that it will be useful,        #
#       but WITHOUT ANY WARRANTY; without even the implied warranty of         #
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          #
#       GNU General Public License for more details.                           #
#                                                                              #
#       You should have received a copy of the GNU General Public License      #
#       along with this program in the file 'COPYING'; if not, write to        #
#       the Free Software Foundation, Inc., 59 Temple Place - Suite 330,       #
#       Boston, MA 02111-1307, USA, or contact the author:                     #
#                                                                              #
#                                   TYNDIUK Frederic <tyndiuk@ftls.org>        #
#                                            <http://www.ftls.org/>            #
#                                                                              #
######################## end license & copyright header ########################
################################################################################
# Necessary Variables & Modules:                                               #
# The following variables should be set to define the locations                #
# and URLs of various files, as explained in the documentation.                #

use CGI;
use strict;

# English
#my @Months_short = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
#my @Months = ('January','February','March','April','May','June','July','August','September','October','November','December');
#my @Week_days_short = ('Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa');

# French
my @Months_short = ('Jan', 'Fv', 'Mar', 'Avr', 'Mai', 'Jui', 'Jui', 'Ao', 'Sep', 'Oct', 'Nov', 'Dc');
my @Months = ('Janvier', 'Fvrier', 'Mars', 'Avril', 'Mai', 'Juin', 'Juillet', 'Aot', 'Septembre', 'Octobre', 'Novembre', 'Dcembre');
my @Week_days_short = ('Di', 'Lu', 'Ma', 'Me', 'Je', 'Ve', 'Sa');


my %params;
my $HOME = "/home/web_user/"; # Absolute path to home stats directory
$params{'OutputDir'}      = $HOME."/out/";
$params{'TemplateCal'}    = $HOME."/present/templates/cal.html";
$params{'BaseReportURL'} = "http://www.yourhost.dom/out";
$params{'NoDailyReports'}   = 0;
$params{'CalTHColor'}       = "#465ba5";
$params{'CalTHTxtColor'}    = "#FFFFFF";
$params{'CalTDColor'}       = "#ADCEE7";
$params{'CalTDTxtColor'}    = "#DE0029";
$params{'CalMonthTxtColor'} = "#000000";

# Nothing Below this line needs to be altered!                                 #
################################################################################
#    DO NOT EDIT ANYTHING BELOW THIS LINE UNLESS YOU KNOW WHAT YOU'RE DOING    #
################################################################################

my (%template_infos);

my $query = new CGI;
print $query->header;

my $day   = $query->param('d');
my $month = $query->param('m');
my $year  = $query->param('y');
my $report_type = $query->param('t');

$template_infos{'scale_date_report_type'} = $query->param('tytxt');
$template_infos{'scale_date_day'} = $day;
$template_infos{'scale_date_mth'} = $Months[$month -1];
$template_infos{'scale_date_yer'} = $year;
$template_infos{'img_up_dir'} = $params{'BaseReportURL'};

my $reports_dir = $params{'OutputDir'};
$reports_dir = $reports_dir."/$year/$month/$day/";


my ($cal, $month_name, $i_txt);
	if ($report_type ne 'y') {
		$cal = &calendar($day, $month, $year, $params{'OutputDir'}, $report_type);
	} else {
		$cal = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<B>$year</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	}
	if ($params{'NoDailyReports'}) {
		$cal = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<B>$year</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	}

	$template_infos{'calendar'} = "<TABLE BORDER=\"0\"><TR><TD VALIGN=\"top\"><FONT FACE=\"Arial\" SIZE=\"1\" COLOR=\"$params{'CalMonthTxtColor'}\">";
	
	for (my $i = 1; $i <= 12; $i++) {
		if ($i < 10) { $i_txt = "0$i" } else  { $i_txt = $i; }
		$month_name = $Months_short[$i -1];
		if (-d $params{'OutputDir'}."$year/$i_txt/")  { 
			$month_name = "<A HREF=\"$params{'BaseReportURL'}/$year/$i_txt/index_cgi.html\" TARGET=\"_top\">$month_name</A>"
		}
		if ($i == 7) { $template_infos{'calendar'} .= "</FONT></TD><TD ALIGN=\"CENTER\">\n$cal\n</TD><TD VALIGN=\"top\"><FONT FACE=\"Arial\" SIZE=\"1\" COLOR=\"$params{'CalMonthTxtColor'}\">"; }
		$template_infos{'calendar'} .= "$month_name<BR>";
	}
	$template_infos{'calendar'} .= "</FONT></TD></TR></TABLE>";

	$_ =  &repace_into_template_file($params{'TemplateCal'}, %template_infos);
	s/index.html/index_cgi.html/g;
	print $_;


########################################
# Calendar Calcul                      #
########################################

sub calendar {
	my ($day, $month, $year, $report_dir_base, $report_type) = @_;
	my ($up, $date, $return, $day_txt);
	my $month_txt = $month;
	
	$up = $params{'BaseReportURL'}."/$year/$month";
	$month++; $month--;
	
	my ($start_day, $days_in_month) = &PerpetualCalendar($month,1,$year);

	my $curr_day = 0;
	$return  = "<table border=0 cellspacing=1 cellpadding=0 bgcolor=\"#FFFFFF\" align=\"center\" bordercolor=\"#FFFFFF\">";
	#$return .= "<TR BGCOLOR=\"$params{'CalTHColor'}\"><TD COLSPAN=7 VALIGN=TOP ALIGN=CENTER><FONT FACE=\"Arial\" SIZE=\"-1\"><B>$Months[$month-1] $year</B></FONT></TD></TR>";
	$return .= "<TR BGCOLOR=\"$params{'CalTHColor'}\">";
	foreach (@Week_days_short) {
		$return .= "<TD width=16 ALIGN=\"CENTER\"><FONT FACE=\"Arial, Helvetica\" SIZE=\"1\" COLOR=\"$params{'CalTHTxtColor'}\"> $_ </font></TD>";
	}
	$return .= "</TR>\n";

	foreach $date (1-$start_day .. $days_in_month) {
		if ($curr_day == 0) { $return .= "<TR BGCOLOR=\"$params{'CalTDColor'}\">"; }
		if ($date > 0) {
			if ($date < 10) { $day_txt = "0$date" } else { $day_txt = $date; }
			if ((-d $report_dir_base."$year/$month_txt/$day_txt/")  && ($date != $day)) {
				$date = "<A HREF=\"$up/$day_txt/index.html\" TARGET=\"_top\">$date</A>";
			}
			if ($date == $day) { $date = "<STRONG><I>$date<I></STRONG>"; }
			$return .= "<TD WIDTH=\"16\" ALIGN=\"CENTER\"><FONT FACE=\"Arial, Helvetica\" SIZE=\"1\" COLOR=\"$params{'CalTDTxtColor'}\">$date</font></TD>";
		} else {
			$return .= "<TD><FONT FACE=\"Arial, Helvetica\" SIZE=\"1\" COLOR=\"$params{'CalTDTxtColor'}\">&nbsp;</FONT></TD>";
		}
		$curr_day++;
		if ($curr_day == 7) {
			$return .= "</TR>\n";
			$curr_day=0;
		}
	}
	return  $return ."</TABLE>\n";
} #end of &calendar()


sub PerpetualCalendar {
	# This perpetual calendar routine provides accurate day/date
	# correspondences for dates from 1601 to 2899 A.D.  It is based on
	# the Gregorian calendar, so be aware that early correspondences
	# may not always be historically accurate.  The Gregorian calendar
	# was adopted by the Italian states, Portugal and Spain in 1582,
	# and by the Catholic German states in 1583.  However, it was not
	# adopted by the Protestant German states until 1699, by England
	# and its colonies until 1752, by Sweden until 1753, by Japan
	# until 1873, by China until 1912, by the Soviet Union until 1918,
	# and by Greece until 1923.
	my ($perp_mon, $perp_day, $perp_year) = @_;
	my ($key, $perp_dow, $perp_eom, $perp_days, $perp_sofar, $perp_togo);
	my %day_counts = (1,0,2,31,3,59,4,90,5,120,6,151,7,181, 8,212,9,243,10,273,11,304,12,334);
	$perp_days = (($perp_year-1601)*365)+(int(($perp_year-1601)/4));
	$perp_days += $day_counts{$perp_mon};
	$perp_days += $perp_day;
	$perp_sofar = $day_counts{$perp_mon};
	$perp_sofar += $perp_day;
	$perp_togo = 365-$perp_sofar;
	if (int(($perp_year-1600)/4) eq (($perp_year-1600)/4)) {
		$perp_togo++;
		if ($perp_mon > 2) {
			$perp_days++;
			$perp_sofar++;
			$perp_togo -= 1;
		}
	}
	foreach $key (1700,1800,1900,2100,2200,2300,2500,2600,2700) {
		if ((($perp_year == $key) && ($perp_mon > 2))
		  || ($perp_year > $key)) {
			$perp_days -= 1;
		}
	}
	$perp_dow = $perp_days - (int($perp_days/7)*7);
	if ($perp_dow == 7) { $perp_dow = 0; }
	$perp_eom = 31;
	if (($perp_mon == 4) || ($perp_mon == 6)
	  || ($perp_mon == 9) || ($perp_mon == 11)) {
		$perp_eom = 30;
	}
	if (($perp_mon == 2)) {
		$perp_eom = 28;
	}
	if ((int(($perp_year-1600)/4) eq (($perp_year-1600)/4))
	  && ($perp_mon == 2)) {
		$perp_eom = 29;
	}
	foreach $key (1700,1800,1900,2100,2200,2300,2500,2600,2700) {
		if ($perp_year == $key) {
			if ($perp_mon == 1) {
				$perp_togo -= 1;
			}
			elsif ($perp_mon == 2) {
				$perp_togo -= 1;
				$perp_eom = 28;
			}
			else {
				$perp_sofar -= 1;
			}
		}
	}
	return ($perp_dow, $perp_eom, $perp_days, $perp_sofar, $perp_togo);
}


########################################
# Litle Common Subs                    #
########################################

sub repace_into_template_file {
	my ($file_name, %data) = @_;
	open(COM, "$file_name") || die("Cannot open 'template file' ($file_name), error: $!",1);
	my $data = join('', <COM>);
	close(COM);
	return &replace_into_template($data, %data);
}

sub replace_into_template {
	my($page, %data) = @_;
	my($key);
	foreach $key ( keys (%data) ) {
		$page =~ s/([^\w])Value_$key([^\w])/$1$data{$key}$2/gi;
	}
	$page =~ s/Value_\w+([^\w])/$1/gi;
	return $page;
}

sub load_txt_file {                                                            
	my($file_name, $error_txt) = @_;
	open(LOAD, "<$file_name") || die("Cannot open $error_txt ($file_name), error: $!");
	my @data = <LOAD>;
	close(LOAD);
	return @data;
}
